"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function IsJsonString(str) {
  try {
    JSON.parse(str);
  } catch (e) {
    return false;
  }
  return true;
}

var isFormData = function isFormData(payload) {

  if (!payload) {
    return false;
  }

  if (typeof FormData !== "undefined") {
    return payload.constructor == new FormData().constructor;
  }

  return typeof payload == "function";
};

var isPlainObject = function isPlainObject(payload) {

  if (!payload) {
    return false;
  }

  var t = {};
  return payload.constructor == t.constructor;
};

exports.default = function (url, headers) {
  var core = {
    ajax: function ajax(method, url, payload, progressReport, abortSignal) {
      return new Promise(function () {
        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(resolve, reject) {
          var client, queryData, isPayloadFormData, data, argcount, key, isDownloadFile, headersObj;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  client = new XMLHttpRequest();

                  abortSignal && abortSignal.addEventListener('abort', function () {
                    client.abort();
                  });
                  queryData = null;
                  isPayloadFormData = isFormData(payload);

                  if (isPayloadFormData) {
                    queryData = payload;
                  } else if (isPlainObject(payload) && (method === 'POST' || method === 'PUT' || method === 'PATCH' || method === 'DELETE')) {
                    queryData = JSON.stringify(payload);
                  } else {
                    data = "";

                    if (isPlainObject(payload)) {
                      argcount = 0;

                      for (key in payload) {
                        if (payload.hasOwnProperty(key)) {
                          if (argcount++) {
                            data += '&';
                          }
                          data += encodeURIComponent(key) + '=' + encodeURIComponent(payload[key]);
                        }
                      }
                    }

                    if (data) {
                      url += url.lastIndexOf("?") == -1 ? "?" + data : "&" + data;
                    }
                  }

                  isDownloadFile = false;

                  if (method == "DOWNLOADFILE") {
                    client.responseType = 'arraybuffer';
                    //client.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
                    method = "GET";
                  }

                  if (method == "POSTPARAMS") {
                    method = "POST";
                  }

                  _context.next = 10;
                  return client.open(method, url, true);

                case 10:

                  if (headers) {
                    headersObj = Object.assign({}, headers);

                    Object.keys(headersObj).forEach(function (headerName) {
                      var headerValue = headersObj[headerName];
                      client.setRequestHeader(headerName, headerValue);
                    });
                  }

                  client.send(queryData);
                  client.addEventListener("loadend", function () {
                    if (client.responseType === 'arraybuffer') {

                      if (this.status === 200) {
                        resolve({ content: this.response,
                          contentType: client.getResponseHeader('Content-Type')
                        });
                      }
                      return;
                    }

                    if (this.status === 200 || this.status === 201 || this.status === 204) {
                      var response = this.response ? this.response : this.responseText;
                      if (!response) {
                        resolve(null);
                      } else {
                        var isJsonString = IsJsonString(response);
                        resolve(isJsonString ? JSON.parse(response) : response);
                      }
                    } else {
                      var responseContent = this.response ? this.response : this.responseText;
                      if (responseContent) {
                        var isJsonString = IsJsonString(responseContent);
                        responseContent = isJsonString ? JSON.parse(responseContent) : responseContent;
                      }

                      reject({ response: { errorResponse: {
                            status: this.status,
                            statusText: this.statusText,
                            servererror: true,
                            clientError: false,
                            data: responseContent,
                            method: method,
                            abortSignal: abortSignal
                          }
                        }
                      });
                    }
                  });

                  if (client.upload) {
                    client.upload.addEventListener("progress", function (evt) {

                      if (evt.lengthComputable) {
                        var percentComplete = evt.loaded / evt.total;
                        percentComplete = parseInt(percentComplete * 100);
                        progressReport && progressReport(percentComplete);
                      }
                    }, false);
                  }

                  client.onerror = function (e) {

                    var responseContent = this.response ? this.response : this.responseText;
                    if (responseContent) {
                      var isJsonString = IsJsonString(responseContent);
                      responseContent = isJsonString ? JSON.parse(responseContent) : responseContent;
                    }

                    reject({ response: { errorResponse: {
                          status: this.status,
                          statusText: this.statusText,
                          servererror: false,
                          clientError: true,
                          data: responseContent,
                          method: method,
                          abortSignal: abortSignal
                        }
                      }
                    });
                  };

                case 15:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  };

  return {
    'get': function get(payload, progressReport, abortSignal) {
      return core.ajax('GET', url, payload, progressReport, abortSignal);
    },
    'post': function post(payload, progressReport, abortSignal) {
      return core.ajax('POST', url, payload, progressReport, abortSignal);
    },
    'postAsParams': function postAsParams(payload, progressReport, abortSignal) {
      return core.ajax('POSTPARAMS', url, payload, progressReport, abortSignal);
    },
    'put': function put(payload, progressReport, abortSignal) {
      return core.ajax('PUT', url, payload, progressReport, abortSignal);
    },
    'delete': function _delete(payload, progressReport, abortSignal) {
      return core.ajax('DELETE', url, payload, progressReport, abortSignal);
    },
    'downloadFile': function downloadFile(payload, progressReport, abortSignal) {
      return core.ajax('DOWNLOADFILE', url, payload, progressReport, abortSignal);
    },
    'patch': function patch(payload, progressReport, abortSignal) {
      return core.ajax('PATCH', url, payload, progressReport, abortSignal);
    }
  };
};